package {

	/*
	 * Represents a sequence of actions to be performed in sequence
	 */

	public class Cinematic {

		public var title : String;
		public var level : uint;
		public var used : Boolean = false;
		public var optional : Boolean = false;
		public var actions : Array; // all the action that comprise this scene

		public function Cinematic(level : uint, title : String) {
			this.title = title;
			this.level = level;
			actions = new Array();
		}

		public function pushAction(action : Action) : void {
			actions.push(action);
		}

		public function updateChar(name : String) : Cinematic {
			var count : uint = 0;
			
			for each (var action : Action in actions) {
				if (action.character == "*") {
					action.character = name;
					count++;
				}
			}
			return this;
		}

		public function toString() : String {
			return "[" + level + ": " + title + "]";
		}
	}
}
