package {

	/**
	 * @author Yori Kvitchko
	 * 
	 * Class used for keeping track of and looping through a set of intervals
	 */
	public class Interval {
		private var _intervals:Array;
		private var _currentInterval:int;
		private var _numIntervals:int;
		private var _timer:Number;
		private var _justTicked:Boolean;

		/*
		 * Intervals is an array of numbers which represents the length of a set of intervals 
		 */
		public function Interval(Intervals:Array) {
			_intervals = Intervals;
			_currentInterval = 0;
			_numIntervals = _intervals.length;
			
			_timer = _intervals[_currentInterval];
			_justTicked = false;
		}

		public function elapse(elapsedTime:Number):void {
			_timer -= elapsedTime;
			
			if(_timer < 0) {
				// Next Interval
				_currentInterval++;
				// Loops
				if(_currentInterval >= _numIntervals)
					_currentInterval = 0;
				// Set new interval time
				_timer = _intervals[_currentInterval];
				
				// Set justTicked
				_justTicked = true;
			} else {
				_justTicked = false;
			}
		}

		public function get currentInterval():int {
			return _currentInterval;
		}

		public function get justTicked():Boolean {
			return _justTicked;
		}
	}
}
