package {
	import org.flixel.FlxG;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;
	import org.flixel.data.FlxPanel;

	public class MenuState extends FlxState {

		[Embed(source="../data/menu_selector2.png")] 
		private var ImgCircle:Class;

		[Embed(source="../data/menu_bg.png")] 
		private var ImgMenu:Class;
		
		[Embed(source="../data/menu_playbutton.png")] 
		private var ImgPlayButton:Class;
		
		[Embed(source="../data/menu_settingsbutton.png")] 
		private var ImgSettingsButton:Class;

		[Embed(source="../data/menu_levelsbutton.png")] 
		private var ImgLevelsButton:Class;

		[Embed(source="../data/menu_exitbutton.png")] 
		private var ImgExitButton:Class;

		[Embed(source="../data/cursor.png")] 
		private var ImgCursor:Class;

		private var _circleButton1:FlxSprite;
		private var _circleButton2:FlxSprite;
		private var _circleButton3:FlxSprite;
		private var _circleButton4:FlxSprite;
//		private var _circleButton5:FlxSprite;
		
		private var _selector:FlxSprite;

		private var _menuBG:FlxSprite;

		/*
		 * Timer
		 */
		private var _fadeTimer:Number;
		/*
		 * Duration
		 */
		private var _fadeDuration:Number;
		/*
		 * In or Out
		 */
		private var _fadeIn:Boolean;
		/*
		 * Action to perform after fade finished
		 */
		private var _fadeAction:Function;
		/*
		 * Helper sprite representing the fade mask
		 */
		private var _fadeMask:FlxSprite;

		override public function create():void {
			
			// adding circle buttons (FlxSprite) onto the screen
			_menuBG = new FlxSprite(0, 0);
			_menuBG.loadGraphic(ImgMenu, false);
			add(_menuBG);
			
			// Play button
			_circleButton1 = new FlxSprite(10, 150);
			_circleButton1.loadGraphic(ImgPlayButton, false);
			add(_circleButton1);
			
			// Levels button
			_circleButton2 = new FlxSprite(440, 180);
			_circleButton2.loadGraphic(ImgSettingsButton, false);
			add(_circleButton2);
			
			// Settings button
			_circleButton3 = new FlxSprite(230, 400);
			_circleButton3.loadGraphic(ImgLevelsButton, false);
			add(_circleButton3);
			
			// Exit button
			_circleButton4 = new FlxSprite(0, 420);
			_circleButton4.loadGraphic(ImgExitButton, false);
			add(_circleButton4);
			
			// Selector
			_selector = new FlxSprite(10, 150);
			_selector.loadGraphic(ImgCircle, true);
			_selector.addAnimation("off", [0], 0); 
			_selector.addAnimation("on", [1], 0);
			add(_selector);
			
			// Fade logic
			_fadeMask = new FlxSprite(0, 0);
			_fadeMask.scrollFactor.x = _fadeMask.scrollFactor.y = 0;
			_fadeMask.createGraphic(FlxG.width, FlxG.height, 0xff000000);
			fadeIn(0.5);
			
			FlxG.mouse.show(ImgCursor, 10, 10);
		}

		override public function update():void {
			// Fade Logic
			if(_fadeDuration > 0) {
				if(_fadeTimer < 0) {
					// Stop fading
					_fadeDuration = 0;
					if(_fadeAction != null)
						_fadeAction();
				} else {
					// Fade
					_fadeTimer -= FlxG.elapsed;
					if(_fadeIn) {
						_fadeMask.alpha = _fadeTimer / _fadeDuration;
					} else {
						_fadeMask.alpha = 1 - _fadeTimer / _fadeDuration;
					}
				
					// Don't do anything while fading
					return;
				}
			}
			
			if(_circleButton1.overlaps(FlxG.mouse.cursor)) {
				resetCircles();	
				onCircle1();	
			}
			else if(_circleButton2.overlaps(FlxG.mouse.cursor)) {
				resetCircles();	
				onCircle2();	
			}
			else if(_circleButton3.overlaps(FlxG.mouse.cursor)) {
				resetCircles();	
				onCircle3();	
			} 
			else if(_circleButton4.overlaps(FlxG.mouse.cursor)) {
				resetCircles();	
				onCircle4();		
			} else {
				resetCircles();	
			}
			
			super.update();
		}

		private function fadeIn(duration:Number, action:Function = null):void {
			_fadeTimer = _fadeDuration = duration;
			_fadeIn = true;
			_fadeAction = action;
		}

		private function fadeOut(duration:Number, action:Function = null):void {
			_fadeTimer = _fadeDuration = duration;
			_fadeIn = false;
			_fadeAction = action;
		}

		private function Play():void {
			FlxG.state = new PlayState();
		}

		private function onCircle1():void {
			_selector.play("on");
			_selector.x=-100;
			_selector.y=100;
			if(FlxG.mouse.justPressed()) {
				fadeOut(0.5, Play);
			}
		}

		private function onCircle2():void {
			_selector.play("on");
			_selector.x=300;
			_selector.y=150;
		}

		private function onCircle3():void {
			_selector.play("on");
			_selector.x=90;
			_selector.y=340;
		}

		
		private function onCircle4():void {
			_selector.play("on");
			_selector.x=-100;
			_selector.y=400;		}

		private function resetCircles():void {
			_selector.play("off");
		}

		override public function postProcess():void {
			if(_fadeDuration > 0) {
				_fadeMask.render();
			}
		}
	}
}

