package {
	import org.flixel.FlxObject;
	import org.flixel.FlxGroup;

	/**
	 * @author Yori Kvitchko
	 */
	public class ObjectPool extends FlxGroup {
		/*
		 * Index of next available object
		 */
		private var _objectIndex:uint;
		
		/*
		 * Creates a pool with specified size using objects of type ObjectClass
		 * ObjectClass must extend FlxObject
		 */
		public function ObjectPool(ObjectClass:Class, poolSize:uint) {
			super();
			
			_objectIndex = 0;
			
			var s:FlxObject;
			
			for (var i:int = 0;i < poolSize;i++) {
				s = new ObjectClass();
				this.add(s);
			}
		}

		/*
		 * Get the next object for use from the pool
		 */
		public function getNextAvail():FlxObject {
			var ret:FlxObject = this.members[_objectIndex];
			
			_objectIndex++;
			if(_objectIndex >= this.members.length)
				_objectIndex = 0;
				
			return ret;
		}

		/*
		 * Index of next available object
		 */
		public function get objectIndex():uint {
			return _objectIndex;
		}
	}
}
