package bosses {
	import org.flixel.FlxGroup;

	/**
	 * @author Yori Kvitchko
	 */
	public class Boss extends FlxGroup {
		public var projectiles:FlxGroup;
		public var percentHealth:Number;
		private var maxHealth:Number;
		
		/*
		 * Object Pool of Sprites representing splat graphics
		 * Splay graphics display when a bullet hits a vulnerable boss component
		 */
		public var splatImagePool:ObjectPool;
		/*
		 * Object Pool of Sprites representing thud graphics
		 * Splay graphics display when a bullet hits an invulnerable boss component
		 */
		public var thudImagePool:ObjectPool;

		/*
		 * FlxGroup representing a single boss or many components all of which
		 * together compromise the boss 
		 */
		public function Boss(Projectiles:FlxGroup, X:Number, Y:Number, Width:Number, Height:Number, Health:Number) {
			super();
			moves = false;
			health = maxHealth = Health;
			percentHealth = 1.0;
			
			projectiles = Projectiles;
			x = X;
			y = Y;
			width = Width;
			height = Height;
			
			splatImagePool = new ObjectPool(SplatImpact, 20);
			thudImagePool = new ObjectPool(ThudImpact, 20);
			
			// Initialize origin
			origin.x = Width / 2;
			origin.y = Height / 2;
		}

		override public function hurt(Damage:Number):void {
			super.hurt(Damage);
			percentHealth = health / maxHealth;
		}
	}
}
