package bosses {
	import org.flixel.FlxObject;
	import org.flixel.FlxSprite;

	import flash.geom.Rectangle;

	/**
	 * @author Yori Kvitchko
	 */
	public class BossHealthComp extends BossComp {
		private var healthBar:FlxSprite;
		private var healthRect:Rectangle;

		/*
		 * Logo Health Image
		 */
		[Embed(source="../../data/boss_health_logo.png")] 
		private var ImgLogo:Class;

		/*
		 * A component of a larger boss, can be either independant or dependant on a parent
		 */
		public function BossHealthComp(X:Number, Y:Number, Parent:FlxObject) {
			super(null, X, Y, Parent);
			x -= width / 2;
			y -= height / 2;
			solid = false;
			
			healthBar = new FlxSprite();
			healthBar.createGraphic(12, 59, 0xffffff00, true);
			healthBar.x = x + 24;
			healthBar.y = y + 1;
			
			healthRect = new Rectangle(0, 0, 12, 0);
		}

		override public function initGraphics():void {
			loadRotatedGraphic(ImgLogo, 32);
		}

		override public function update():void {
			healthBar.angle = angle = _parent.angle;
			healthBar.x = x + 24;
			healthBar.y = y + 1;
			healthRect.height = Math.floor((1 - Boss(_parent).percentHealth) * 59);
			super.update();
		}

		override public function render():void {
			healthBar.pixels.fillRect(healthRect, 0xffff0000);
			healthBar.frame = 0;
			healthBar.render();
			super.render();
		}
	}
}
