package bosses.doomstroyer {
	import base.Proj;
	import base.ProjSpawner;

	import org.flixel.FlxObject;
	import org.flixel.FlxU;

	/**
	 * @author Yori Kvitchko
	 */
	public class DoomCircleSpawner extends ProjSpawner {
		private static const BULLET_SPEED:Number = 400;
		
		public var projAngle:Number;

		public function DoomCircleSpawner(X:Number, Y:Number, Interval:Number, ProjectileAngle:Number, FollowTarget:FlxObject = null) {
			super(X, Y, Interval, Proj, 300, FollowTarget);
			projAngle = ProjectileAngle;
		}

		override public function sendProjectile(X:Number, Y:Number, p:Proj, locationIndex:int):void {
			var tmpAngle:Number = projAngle + locationIndex * (360 / _spawnLocations.length);
			
			// Send it
			super.sendProjectile(X, Y, p, locationIndex);
			// Set Parameters
			Proj(p).velocity = FlxU.rotatePoint(BULLET_SPEED, 0, 0, 0, tmpAngle);
			// Set Angle
			Proj(p).angle = tmpAngle;
		}
	}
}
