package bosses.duck {
	import base.Proj;

	import org.flixel.FlxG;

	/**
	 * @author Yori Kvitchko
	 */
	public class DuckProj extends Proj {

		// CONSTANTS

		// VARIABLES

		private var _popImpact:DuckProjImpact;

		// EMBEDDED RESOURCES

		[Embed(source="../../../data/boss_duck_bullet.png")] 
		private var ImgSquidBullet:Class;

		/*
		 * Bullet for the squid
		 */
		public function DuckProj() {
			super();
			angle = Math.random() * 360;
			_popImpact = new DuckProjImpact();
		}

		/*
		 * Initialize Graphics
		 */
		override public function initGraphics():void {
			loadRotatedGraphic(ImgSquidBullet, 90);
		}

		override public function update():void {
			super.update();
			angle += 1;
			if(scale.x < 3) {
				scale.x += 1 * FlxG.elapsed;
				scale.y += 1 * FlxG.elapsed;
				updateCollision();
			} else {
				kill();
			}
			
		}

		public function updateCollision():void {
			width = frameWidth * scale.x * 0.65;
			height = frameHeight * scale.y * 0.65;
			offset.x = (frameWidth - width * 0.975) / 2;
			offset.y = (frameHeight - height * 0.975) / 2;
		}

		override public function reset(X:Number, Y:Number):void {
			super.reset(X + frameWidth / 2, Y + frameHeight / 2);
			scale.x = 0.01;
			scale.y = 0.01;
			updateCollision();
		}

		override public function kill():void {
			super.kill();
			
			if(!_popImpact.added) {
				PlayState(FlxG.state).sv.enemyProjectiles.add(_popImpact);
			}
			
			_popImpact.reset(x, y);
			_popImpact.width = width;
			_popImpact.height = height;
			_popImpact.offset.x = offset.x;
			_popImpact.offset.y = offset.y;
			_popImpact.scale.x = scale.x;
			_popImpact.scale.y = scale.y;
		}
	}
}
