package bosses.whip {
	import base.Proj;

	import org.flixel.FlxG;

	/**
	 * @author Yori Kvitchko
	 */
	public class WhipProj extends Proj {
		// 0 for not exploding, anything else for index of exploder to use
		public var exploding:int;
		
		public function WhipProj() {
			super();
			exploding = 0;
		}

		override public function initGraphics():void {
			createGraphic(10, 10);
		}

		override public function reset(X:Number, Y:Number):void {
			if(exploding > 0) {
				WhipBoss(PlayState(FlxG.state).sv.enemy).triggerExplosion(x, y, exploding - 1);
				exploding = 0;
			}
			
			super.reset(X, Y);
		}

		override public function kill():void {
			super.kill();
			exploding = 0;
		}
	}
}
